#if !defined(AFX_WRITELAYOUT_H__575751F3_6F4D_4CE7_B1AE_44D50D5C0FFC__INCLUDED_)
#define AFX_WRITELAYOUT_H__575751F3_6F4D_4CE7_B1AE_44D50D5C0FFC__INCLUDED_

// WRITELAYOUT.H - Header file for your Internet Server
//    WriteLayout Extension

#include "resource.h"


//******************************************************************************************
//MACROS HERE
#define MACRO_BEGIN char					wcOut[4000];											\
	*bstrOutput								=L"";													\
	try																								\
	{	CAdoRecordset*	AdoRS	= new CAdoRecordset;				/*create a recordset variable*/	\
		if ( DBConnectionOpen( m_bstrConnectionString, &AdoDB ) )/*look at db connection to be online*/\
		{															/*open the recordset*/			\
			if ( AdoRS->Open(AdoDB.GetActiveConnection(), bstrSTMT, adOpenForwardOnly, adLockReadOnly, adUseClient ) )	/*here the disc params*/ \
			{	


#define MACRO_END	AdoRS->Close();									/*close the recordset*/			\
					if (AdoRS)	delete AdoRS;														\
			}																						\
			else													/*set the custom error*/		\
			{	wsprintf(wcOut, "Encountered Error :<br>%s<br>%s<br>%s<br>%s<br>", "GetMarketMapData", (LPCTSTR)AdoDB.GetLastError(), "RS isn't open", bstrSTMT  );\
				*bstrError		= wcOut ;															\
				return false;																		\
			}																						\
		}																							\
		else														/*set the custom error*/		\
		{	wsprintf(wcOut, "Encountered Error :<br>%s<br>%s<br>%s<br>%s<br>", "GetMarketMapData", (LPCTSTR)AdoDB.GetLastError(), "DB isn't open", bstrSTMT  );\
			*bstrError		= wcOut;																\
			return false;																			\
		}																							\
	}																								\
	catch(_com_error err)																			\
	{																/*set the COM error*/			\
		wsprintf(wcOut, "Encountered Error :<br>%s<br>%d<br>%s<br>", (LPSTR)err.Description(), err.Error(), (LPSTR)err.ErrorMessage()  );\
		*bstrError		= wcOut ;																	\
		return false;																				\
	}																								\
	return true;

//******************************************************************************************


class CWriteLayoutExtension : public CHttpServer
{
public:
	CWriteLayoutExtension();
	~CWriteLayoutExtension();

// Overrides
	// ClassWizard generated virtual function overrides
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//{{AFX_VIRTUAL(CWriteLayoutExtension)
	public:
	virtual BOOL GetExtensionVersion(HSE_VERSION_INFO* pVer);
	//}}AFX_VIRTUAL
	virtual BOOL TerminateExtension(DWORD dwFlags);

	// TODO: Add handlers for your commands here.
	// For example:

	void	Default(CHttpServerContext* pCtxt);
	

	void	WritePageDemo(CHttpServerContext* pCtxt);
	void	WritePageDB2Web(CHttpServerContext* pCtxt);

	//database methods
	bool							DBConnectionOpen( _bstr_t bstrConnection, CAdoDatabase	*AdoDB );
	

	//attributes
	//database attributes
	_bstr_t							m_bstrConnectionString;
    

 
private:
	bool GetArticlesFeature(CAdoDatabase AdoDB, _bstr_t *bstrOutput, _bstr_t *bstrError);
	bool GetArticlesTopRated(CAdoDatabase AdoDB, _bstr_t *bstrOutput, _bstr_t *bstrError);
	bool GetArticlesLast10(CAdoDatabase AdoDB, _bstr_t *bstrOutput, _bstr_t *bstrError);

	//helper methods:
	BOOL	LoadLongResource(CString& str, UINT nID);

	CString strOutput;
	CString strPageDemo, strPagePart1, strPagePart2, strPagePart3, strPagePart4;
	



	DECLARE_PARSE_MAP()

	//{{AFX_MSG(CWriteLayoutExtension)
	//}}AFX_MSG
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WRITELAYOUT_H__575751F3_6F4D_4CE7_B1AE_44D50D5C0FFC__INCLUDED)
